<?php
/*
Plugin Name: NBC LinkUser2PunBB
Version: 1.0.b
Description: Permet de lier les changements sur les utilisateurs de PWG avec ceux d un forum PunBB (creation, changement de mot de passe, suppression). Bas sur le MOD de Flipflip et sur le plugin de Eric.
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=218
Author: Nicco
Author URI: http://gallery-nicco.no-ip.org
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('NBC_LinkUser2PunBB_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');



/* administration du plugin */
add_event_handler('get_admin_plugin_menu_links', 'nbc_LinkUser2PunBB_admin_menu');

function nbc_LinkUser2PunBB_admin_menu($menu)
{
  array_push($menu,
    array(
      'NAME' => 'LinkUser2PunBB',
      'URL'  => get_admin_plugin_menu_link(NBC_LinkUser2PunBB_PATH.'/admin/LinkUser2PunBB_admin.php')
    )
  );

  return $menu;
}



/* creation de user */
add_event_handler('register_user', 'LinkUser2PunBB_Adduser');

function LinkUser2PunBB_Adduser($register_user)
{
	global $conf;
	
  include_once (NBC_LinkUser2PunBB_PATH.'include/functions_LinkUser2PunBB.inc.php');

  PunBB_Adduser($register_user['username'], $conf['pass_convert']($_POST['password']), $register_user['email']);

  PunBB_Linkuser($register_user['id']);
}



/* suppression de user */
add_event_handler('delete_user', 'LinkUser2PunBB_Deluser');

function LinkUser2PunBB_Deluser($user_id)
{
	include_once (NBC_LinkUser2PunBB_PATH.'include/functions_LinkUser2PunBB.inc.php');

  PunBB_Deluser( PunBB_Searchuser($user_id), true );

  PunBB_Unlinkuser($user_id);
}



add_event_handler('init', 'LinkUser2PunBB_InitPage');
 
function LinkUser2PunBB_InitPage()
{
  global $conf, $template, $page;

  include_once (NBC_LinkUser2PunBB_PATH.'include/functions_LinkUser2PunBB.inc.php');
  
  
 
/* mise a jour de user */
  if (script_basename() == 'profile')
  {
    if (isset($_POST['validate']))
    {
      $errors = array();

      $int_pattern = '/^\d+$/';
      if (empty($_POST['nb_image_line'])
          or (!preg_match($int_pattern, $_POST['nb_image_line'])))
      {
        $errors[] = l10n('nb_image_line_error');
      }
    
      if (empty($_POST['nb_line_page'])
          or (!preg_match($int_pattern, $_POST['nb_line_page'])))
      {
        $errors[] = l10n('nb_line_page_error');
      }
    
      if ($_POST['maxwidth'] != ''
          and (!preg_match($int_pattern, $_POST['maxwidth'])
               or $_POST['maxwidth'] < 50))
      {
        $errors[] = l10n('maxwidth_error');
      }
      if ($_POST['maxheight']
           and (!preg_match($int_pattern, $_POST['maxheight'])
                 or $_POST['maxheight'] < 50))
      {
        $errors[] = l10n('maxheight_error');
      }
      // periods must be integer values, they represents number of days
      if (!preg_match($int_pattern, $_POST['recent_period'])
          or $_POST['recent_period'] <= 0)
      {
        $errors[] = l10n('periods_error') ;
      }
    
      if (isset($_POST['mail_address']))
      {
        $mail_error = validate_mail_address($_POST['mail_address']);
        if (!empty($mail_error))
        {
          $errors[] = $mail_error;
        }
      }
    
      if (!empty($_POST['use_new_pwd']))
      {
        // password must be the same as its confirmation
        if ($_POST['use_new_pwd'] != $_POST['passwordConf'])
        {
          $errors[] = l10n('New password confirmation does not correspond');
        }
    
        if ( !defined('IN_ADMIN') )
        {// changing password requires old password
          $query = '
            SELECT '.$conf['user_fields']['password'].' AS password
            FROM '.USERS_TABLE.'
            WHERE '.$conf['user_fields']['id'].' = \''.$_POST['userid'].'\'
          ;';
          list($current_password) = mysql_fetch_row(pwg_query($query));
      
          if ($conf['pass_convert']($_POST['password']) != $current_password)
          {
            $errors[] = l10n('Current password is wrong');
          }
        }
      }
    
      if (count($errors) == 0)
      {
      	include_once (NBC_LinkUser2PunBB_PATH.'include/functions_LinkUser2PunBB.inc.php');
      
        PunBB_Updateuser($_POST['userid'], $conf['pass_convert']($_POST['use_new_pwd']), $_POST['mail_address']);
      }
    }
  }
}



?>
